
package cz.moneta.test.dsl.cebia.iva;

import jakarta.xml.bind.annotation.XmlAccessType;
import jakarta.xml.bind.annotation.XmlAccessorType;
import jakarta.xml.bind.annotation.XmlElement;
import jakarta.xml.bind.annotation.XmlSchemaType;
import jakarta.xml.bind.annotation.XmlType;
import javax.xml.datatype.XMLGregorianCalendar;


/**
 * <p>Java class for WSVehicleVersionType complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="WSVehicleVersionType"&gt;
 *   &lt;complexContent&gt;
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
 *       &lt;sequence&gt;
 *         &lt;element name="VersionName" type="{http://www.w3.org/2001/XMLSchema}string" minOccurs="0"/&gt;
 *         &lt;element name="VersionState" type="{http://samo.cz/iva/}WSVersionStateEnum" minOccurs="0"/&gt;
 *         &lt;element name="VersionOnMarketIntroduced" type="{http://www.w3.org/2001/XMLSchema}dateTime" minOccurs="0"/&gt;
 *         &lt;element name="VersionOnMarketConcluded" type="{http://www.w3.org/2001/XMLSchema}dateTime" minOccurs="0"/&gt;
 *         &lt;element name="VersionSpecificationChanged" type="{http://www.w3.org/2001/XMLSchema}dateTime" minOccurs="0"/&gt;
 *         &lt;element name="Price" type="{http://samo.cz/iva/}WSPriceType" minOccurs="0"/&gt;
 *         &lt;element name="BasePrice" type="{http://samo.cz/iva/}WSPriceType" minOccurs="0"/&gt;
 *         &lt;element name="Discount" type="{http://samo.cz/iva/}WSPriceType" minOccurs="0"/&gt;
 *       &lt;/sequence&gt;
 *     &lt;/restriction&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "WSVehicleVersionType", propOrder = {
    "versionName",
    "versionState",
    "versionOnMarketIntroduced",
    "versionOnMarketConcluded",
    "versionSpecificationChanged",
    "price",
    "basePrice",
    "discount"
})
public class WSVehicleVersionType {

    @XmlElement(name = "VersionName", nillable = true)
    protected String versionName;
    @XmlElement(name = "VersionState")
    @XmlSchemaType(name = "string")
    protected WSVersionStateEnum versionState;
    @XmlElement(name = "VersionOnMarketIntroduced", nillable = true)
    @XmlSchemaType(name = "dateTime")
    protected XMLGregorianCalendar versionOnMarketIntroduced;
    @XmlElement(name = "VersionOnMarketConcluded", nillable = true)
    @XmlSchemaType(name = "dateTime")
    protected XMLGregorianCalendar versionOnMarketConcluded;
    @XmlElement(name = "VersionSpecificationChanged", nillable = true)
    @XmlSchemaType(name = "dateTime")
    protected XMLGregorianCalendar versionSpecificationChanged;
    @XmlElement(name = "Price", nillable = true)
    protected WSPriceType price;
    @XmlElement(name = "BasePrice", nillable = true)
    protected WSPriceType basePrice;
    @XmlElement(name = "Discount", nillable = true)
    protected WSPriceType discount;

    /**
     * Gets the value of the versionName property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getVersionName() {
        return versionName;
    }

    /**
     * Sets the value of the versionName property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setVersionName(String value) {
        this.versionName = value;
    }

    /**
     * Gets the value of the versionState property.
     * 
     * @return
     *     possible object is
     *     {@link WSVersionStateEnum }
     *     
     */
    public WSVersionStateEnum getVersionState() {
        return versionState;
    }

    /**
     * Sets the value of the versionState property.
     * 
     * @param value
     *     allowed object is
     *     {@link WSVersionStateEnum }
     *     
     */
    public void setVersionState(WSVersionStateEnum value) {
        this.versionState = value;
    }

    /**
     * Gets the value of the versionOnMarketIntroduced property.
     * 
     * @return
     *     possible object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public XMLGregorianCalendar getVersionOnMarketIntroduced() {
        return versionOnMarketIntroduced;
    }

    /**
     * Sets the value of the versionOnMarketIntroduced property.
     * 
     * @param value
     *     allowed object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public void setVersionOnMarketIntroduced(XMLGregorianCalendar value) {
        this.versionOnMarketIntroduced = value;
    }

    /**
     * Gets the value of the versionOnMarketConcluded property.
     * 
     * @return
     *     possible object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public XMLGregorianCalendar getVersionOnMarketConcluded() {
        return versionOnMarketConcluded;
    }

    /**
     * Sets the value of the versionOnMarketConcluded property.
     * 
     * @param value
     *     allowed object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public void setVersionOnMarketConcluded(XMLGregorianCalendar value) {
        this.versionOnMarketConcluded = value;
    }

    /**
     * Gets the value of the versionSpecificationChanged property.
     * 
     * @return
     *     possible object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public XMLGregorianCalendar getVersionSpecificationChanged() {
        return versionSpecificationChanged;
    }

    /**
     * Sets the value of the versionSpecificationChanged property.
     * 
     * @param value
     *     allowed object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public void setVersionSpecificationChanged(XMLGregorianCalendar value) {
        this.versionSpecificationChanged = value;
    }

    /**
     * Gets the value of the price property.
     * 
     * @return
     *     possible object is
     *     {@link WSPriceType }
     *     
     */
    public WSPriceType getPrice() {
        return price;
    }

    /**
     * Sets the value of the price property.
     * 
     * @param value
     *     allowed object is
     *     {@link WSPriceType }
     *     
     */
    public void setPrice(WSPriceType value) {
        this.price = value;
    }

    /**
     * Gets the value of the basePrice property.
     * 
     * @return
     *     possible object is
     *     {@link WSPriceType }
     *     
     */
    public WSPriceType getBasePrice() {
        return basePrice;
    }

    /**
     * Sets the value of the basePrice property.
     * 
     * @param value
     *     allowed object is
     *     {@link WSPriceType }
     *     
     */
    public void setBasePrice(WSPriceType value) {
        this.basePrice = value;
    }

    /**
     * Gets the value of the discount property.
     * 
     * @return
     *     possible object is
     *     {@link WSPriceType }
     *     
     */
    public WSPriceType getDiscount() {
        return discount;
    }

    /**
     * Sets the value of the discount property.
     * 
     * @param value
     *     allowed object is
     *     {@link WSPriceType }
     *     
     */
    public void setDiscount(WSPriceType value) {
        this.discount = value;
    }

    public WSVehicleVersionType withVersionName(String value) {
        setVersionName(value);
        return this;
    }

    public WSVehicleVersionType withVersionState(WSVersionStateEnum value) {
        setVersionState(value);
        return this;
    }

    public WSVehicleVersionType withVersionOnMarketIntroduced(XMLGregorianCalendar value) {
        setVersionOnMarketIntroduced(value);
        return this;
    }

    public WSVehicleVersionType withVersionOnMarketConcluded(XMLGregorianCalendar value) {
        setVersionOnMarketConcluded(value);
        return this;
    }

    public WSVehicleVersionType withVersionSpecificationChanged(XMLGregorianCalendar value) {
        setVersionSpecificationChanged(value);
        return this;
    }

    public WSVehicleVersionType withPrice(WSPriceType value) {
        setPrice(value);
        return this;
    }

    public WSVehicleVersionType withBasePrice(WSPriceType value) {
        setBasePrice(value);
        return this;
    }

    public WSVehicleVersionType withDiscount(WSPriceType value) {
        setDiscount(value);
        return this;
    }

}
